<template>
  <div>
    <div class="flex flex-col">
      <div class="flex flex-row">
        <info-cell>Id</info-cell>
        <info-cell>Name</info-cell>
        <info-cell>rank</info-cell>
        <info-cell>profession</info-cell>
        <info-cell>acceptance_date</info-cell>
        <info-cell>logde_id</info-cell>
        <AddButton @click="() => $emit('on_add')" />
      </div>
      <MasonInfo v-for="mason of masons" :key="mason.id" :id="mason.id" :view="editable"
        :edit="editable" @on_edit="() => $emit('on_edit', mason.id)"
        @on_view="() => $emit('on_view', mason.id)"
        @on_remove="() => $emit('on_remove', mason.id)" />
    </div>
    <div class="my-7 flex justify-center">
      <CancelButton value="return" class="w-1/2" @click="goBack" />
    </div>
  </div>
</template>

<script>
import MasonInfo from '@/components/MasonInfo.vue'
import InfoCell from '@/components/InfoCell.vue';
import AddButton from '@/components/AddButton.vue';
import CancelButton from '@/components/CancelButton.vue';
import { mapGetters } from 'vuex';

export default {
  props: ['editable'],
  emits: ['on_edit', 'on_remove', 'on_view', 'on_add'],
  data() {
    return {

    }
  },
  components: {
    MasonInfo,
    InfoCell,
    AddButton,
    CancelButton
  },
  methods: {
    goBack() {
      this.$router.go(-1)
    }
  },
  computed: {
    ...mapGetters({
      masons: 'getMasons'
    })
  }
}

</script>